// източници:
// - https://docs.arduino.cc/learn/microcontrollers/analog-output
// - https://www.arduino.cc/reference/en/language/functions/analog-io/analogwrite/
// Тази програма е почти същата като предишната по номер, но с много по-малко
// debug инфромация, за да е видимо колко малко код всъщност е необходим,
// за да осъчествим постъпателно усилване и намаляване на яркостта на светодиод
// Ако го правехме с цикъл, щяха да са ни нужни два цикъла:
// един за един за увеличаването и един за намаляването на яркостта.
// С рекурсията това се случва много по-елегантно, тъй като разполагаме
// с двете ѝ посоки - гмуркането към дъното и изплуването обратно към повърхността.
// Точно това искаме да постигнем и със светодиода, затова считам тази програма
// за чудесна демонстрация на начина, по който работи рекурсията.

#define LED_PIN 9
#define PAXSO 10

void xsaltiLed(short valoro) {
  analogWrite(LED_PIN, valoro);
  delay(1000);
}

// рекурсивна функция, която кара лампичката да увеличава и намалява яркостта си от 0 до 255 и обратно
void fade(short valoro) {

  // провери дали стойността е валидна
  if (valoro > 255) {
    // стойността е невалидна, което означава, че това е последната функция - дъното на рекурсията
    xsaltiLed(255); // светни лампичката с най-голямата валидна стойност
    return; // прекрати изпълнението на тази последна функция по веригата, за да започне връщането назад по предишните в обратен ред
  }
  
  xsaltiLed(valoro);    // светни лампичката преди да създадеш детето си
  fade(valoro + PAXSO); // създай детето си
  xsaltiLed(valoro);    // светни отново лампичката след като детето и всичите негови наследници са приключили изпълнението си
}

void setup() {
  delay(500);
  Serial.begin(9400);
}

void loop() {
  fade(0);
  Serial.println();
}
